Class: Brakeman::CheckSafeBufferManipulation

Inherits:
BaseCheck show all
Defined in:
lib/brakeman/checks/check_safe_buffer_manipulation.rb

Overview

Check for unsafe manipulation of strings Right now this is just a version check for groups.google.com/group/rubyonrails-security/browse_thread/thread/edd28f1e3d04e913?pli=1

Constant Summary

Constants inherited from BaseCheck

BaseCheck::CONFIDENCE

Constants included from Util

Util::ALL_PARAMETERS, Util::COOKIES, Util::COOKIES_SEXP, Util::PARAMETERS, Util::PARAMS_SEXP, Util::PATH_PARAMETERS, Util::QUERY_PARAMETERS, Util::REQUEST_ENV, Util::REQUEST_PARAMETERS, Util::REQUEST_PARAMS, Util::SESSION, Util::SESSION_SEXP

Constants inherited from SexpProcessor

SexpProcessor::VERSION

Instance Attribute Summary

Attributes inherited from BaseCheck

#tracker, #warnings

Attributes inherited from SexpProcessor

#context, #env, #expected

Instance Method Summary collapse

Methods inherited from BaseCheck

#add_result, inherited, #initialize, #process_call, #process_cookies, #process_default, #process_if, #process_params, #process_string_interp

Methods included from Util

#array?, #block?, #call?, #camelize, #contains_class?, #context_for, #cookies?, #false?, #file_by_name, #file_for, #github_url, #hash?, #hash_access, #hash_insert, #hash_iterate, #integer?, #make_call, #node_type?, #number?, #params?, #pluralize, #regexp?, #relative_path, #request_env?, #request_value?, #result?, #set_env_defaults, #sexp?, #string?, #symbol?, #table_to_csv, #template_path_to_name, #true?, #truncate_table, #underscore

Methods included from ProcessorHelper

#class_name, #process_all, #process_all!, #process_call_args, #process_class, #process_module

Methods inherited from SexpProcessor

#error_handler, #in_context, #initialize, #process, #process_dummy, #scope

Constructor Details

This class inherits a constructor from Brakeman::BaseCheck

Instance Method Details

#run_checkObject


11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
# File 'lib/brakeman/checks/check_safe_buffer_manipulation.rb', line 11

def run_check

  if version_between? "3.0.0", "3.0.11"
    suggested_version = "3.0.12"
  elsif version_between? "3.1.0", "3.1.3"
    suggested_version = "3.1.4"
  elsif version_between? "3.2.0", "3.2.1"
    suggested_version = "3.2.2"
  else
    return
  end

  message = "Rails #{tracker.config[:rails_version]} has a vulnerabilty in SafeBuffer. Upgrade to #{suggested_version} or apply patches."

  warn :warning_type => "Cross Site Scripting",
    :warning_code => :safe_buffer_vuln, 
    :message => message,
    :confidence => CONFIDENCE[:med],
    :gem_info => gemfile_or_environment
end